﻿Imports System
Imports System.ComponentModel
Imports System.Runtime.Serialization

Public Class CommonBase
    Implements INotifyPropertyChanged

#Region "Constructor"
    Protected Sub New()
    End Sub
#End Region

#Region "INotifyPropertyChanged Implementation"
    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    ''' <summary>
    ''' The PropertyChanged Event to raise to any UI object
    ''' The event is only invoked if data binding is used
    ''' </summary>
    ''' <param name="propertyName">The property name that is changing</param>          
    Protected Overridable Sub RaisePropertyChanged(ByVal propertyName As String)
        Dim handler As PropertyChangedEventHandler = Me.PropertyChangedEvent
        If handler IsNot Nothing Then
            Dim e = New PropertyChangedEventArgs(propertyName)
            handler(Me, e)
        End If
    End Sub
#End Region

End Class
