﻿Imports System.ComponentModel
Imports System.Collections.ObjectModel
Imports System.ServiceModel

Class viewModelLog
    Inherits CommonBase

    Private Function CreateLogDataObject() As LogData
        Dim ret As New LogData()

        ret.ConnectString = ret.GetConnectString()

        Return ret
    End Function

    Private _DataCollection As LogCollection

    Public Property DataCollection As LogCollection
        Get
            Return _DataCollection
        End Get
        Set(ByVal value As LogCollection)
            _DataCollection = value
            RaisePropertyChanged("DataCollection")
        End Set
    End Property

    Private _vmMessage As String = String.Empty

    Public Property vmMessage As String
        Get
            Return _vmMessage
        End Get
        Set(ByVal value As String)
            _vmMessage = value
            RaisePropertyChanged("vmMessage")
        End Set
    End Property

    Private sw As New Stopwatch()


    Public Sub New()
        MyBase.New()

        DataCollection = New LogCollection()
    End Sub

    Public Sub LoadData()
        DataCollection = New LogCollection()

        Dim data As LogData = Nothing

        sw.Start()

        Try
            data = CreateLogDataObject()

            DataCollection = data.BuildCollection()
            sw.Stop()
            If DataCollection Is Nothing Then
                vmMessage = "No records were found for this table."
            Else
                vmMessage = "Total Records : " + DataCollection.Count.ToString() + ", used time : " + sw.Elapsed.Milliseconds.ToString()
            End If
        Catch ex As Exception
            vmMessage = ex.Message
            MsgBox(ex.Message)
        End Try
    End Sub



End Class