﻿Imports System.Windows.Threading

Public Class winWpfListView
    Private _ViewModel As viewModelLog = Nothing

    Public Sub New()
        InitializeComponent()

        ' Grab the Instance of the ViewModel
        _ViewModel = DirectCast(Me.FindResource("viewModel"), viewModelLog)

    End Sub

    Private Sub btnLoad_Click()
        _ViewModel.vmMessage = "Loading ... Please wait ..."

        Dim fetcher As New NoArgDelegate(AddressOf Me.RetrieveDataFromServer)

        fetcher.BeginInvoke(Nothing, Nothing)
    End Sub

    Private Sub RetrieveDataFromServer()

        Try

            _ViewModel.LoadData()

            ' Schedule the update function in the UI thread. 
            Me.Dispatcher.BeginInvoke(System.Windows.Threading.DispatcherPriority.Normal, New OneArgDelegate(AddressOf UpdateUserInterface), _ViewModel.DataCollection)

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    Public Delegate Sub NoArgDelegate()
    Public Delegate Sub OneArgDelegate(ByVal arg As Object)
    Private Delegate Sub NextPrimeDelegate()

    Public Sub UpdateView()

        If _ViewModel.DataCollection IsNot Nothing Then
            _ViewModel.vmMessage = "Total Records : " + _ViewModel.DataCollection.Count.ToString()
        Else
            _ViewModel.vmMessage = "No records were found for this table."
        End If

    End Sub

    Private Sub UpdateUserInterface(ByVal data As Object)

        Me.Dispatcher.BeginInvoke(DispatcherPriority.Normal, New NextPrimeDelegate(AddressOf UpdateView))

    End Sub

End Class
