﻿Imports Syncfusion.UI.Xaml.Grid
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Data
Imports System.Text
Imports System.Windows
Imports System.Windows.Interactivity
Imports Syncfusion.UI.Xaml.Grid.Helpers

Public Class QueryRowHeightBehaviour
    Inherits Behavior(Of SfDataGrid)

    Private gridRowResizingOptions As New GridRowSizingOptions()
    Private excludeColumns As New List(Of String)()
    Private Height As Double = Double.NaN

    Protected Overrides Sub OnAttached()
        AddHandler Me.AssociatedObject.ItemsSourceChanged, AddressOf AssociatedObject_ItemsSourceChanged
        AddHandler Me.AssociatedObject.QueryRowHeight, AddressOf AssociatedObject_QueryRowHeight
    End Sub

    Private Sub AssociatedObject_ItemsSourceChanged(ByVal sender As Object, ByVal e As GridItemsSourceChangedEventArgs)
        'For Each column In Me.AssociatedObject.Columns
        '    If Not column.MappingName.Equals("Address") AndAlso Not column.MappingName.Equals("CompanyName") Then
        '        excludeColumns.Add(column.MappingName)
        '    End If
        'Next column

        'gridRowResizingOptions.ExcludeColumns = excludeColumns
    End Sub

    Private Sub AssociatedObject_QueryRowHeight(ByVal sender As Object, ByVal e As QueryRowHeightEventArgs)
        If Me.AssociatedObject.IsTableSummaryIndex(e.RowIndex) Then
            e.Height = 40
            e.Handled = True
        ElseIf Me.AssociatedObject.GridColumnSizer.GetAutoRowHeight(e.RowIndex, gridRowResizingOptions, Height) Then
            If Height > Me.AssociatedObject.RowHeight Then
                e.Height = Height
                e.Handled = True
            End If
        End If
    End Sub

    Protected Overrides Sub OnDetaching()
        RemoveHandler Me.AssociatedObject.QueryRowHeight, AddressOf AssociatedObject_QueryRowHeight
        RemoveHandler Me.AssociatedObject.ItemsSourceChanged, AddressOf AssociatedObject_ItemsSourceChanged
    End Sub

End Class
